# QuickThickness

import win32com.client
from win32com.client import constants

null = None
false = 0
true = 1

def XSILoadPlugin( in_reg ):
    in_reg.Author = "eistan"
    in_reg.Name = "QuickThickness"
    in_reg.Major = 1
    in_reg.Minor = 0

    in_reg.RegisterCommand("QuickThickness","QuickThickness")
    in_reg.RegisterMenu(constants.siMenu3DViewObjectMeshContextID,"QuickThickness_Menu",false,false)
    in_reg.RegisterMenu(constants.siMenuTbModelModifyPolygonMeshID,"QuickThickness_Menu",false,false)
    #RegistrationInsertionPoint - do not remove this line

    return true

def XSIUnloadPlugin( in_reg ):
    strPluginName = in_reg.Name
    Application.LogMessage(str(strPluginName) + str(" has been unloaded."),constants.siVerbose)
    return true

def QuickThickness_Init( in_ctxt ):
    oCmd = in_ctxt.Source
    oCmd.Description = ""
    oCmd.ReturnValue = true

    return true

def QuickThickness_Execute(  ):

    a = Application
    sel = a.Selection
    lm = LogMessage

    import win32com
    c = win32com.client.constants

    listx = []
    lista = []
    listo = []

    oProgressBar = XSIUIToolkit.ProgressBar
    oProgressBar.Maximum = sel.Count

    oProgressBar.Caption = "Quick Thickness Process..."
    oProgressBar.Visible = True

    bb = 0
    lm(bb)
    for x in range(0, sel.Count):
        if not sel(x).ActivePrimitive.ConstructionHistory.Find( "extrudenormalop" ):
            for y in range(0, sel(x).activeprimitive.geometry.Edges.Count):
                if sel(x).activeprimitive.geometry.Edges(y).IsBoundary == True:
                    bb = 0
                    lm(bb)
                    listx.append(sel(x).Name)
                    break
                else:
                    bb = 1
                    lm(bb)
        else:
            lista.append(sel(x).Name)
        if bb == 1:
            listo.append(sel(x).Name)

    if listo:
        lm(listo)
        XSIUIToolkit.Msgbox("Objects " + str(', '.join(listo)) + " dont have boundary edges! You need select objects with boundary edges!")

    if listx:
        for y in range(0, len(listx)):
            a.SelectObj(listx[y], "", True)
            a.SelectGeometryComponents(".poly[*]")
            a.DuplicateMeshComponent("", "siPersistentOperation", "", "", "", "", "", "", "", "", "", "", "", "", True)
            a.ApplyTopoOp("InvertPolygon", "", "siUnspecified", "siPersistentOperation", "")
            a.ApplyTopoOp("ExtrudeComponentNormal", "", "siUnspecified", "siPersistentOperation", "")
            a.SelectObj(listx[y], "", True)
            a.SetSelFilter("Border_Edge")
            a.SelectAllUsingFilter("Border_Edge", "siCheckComponentVisibility", "", "")
            a.ApplyTopoOp("WeldEdges", "", "siUnspecified", "siPersistentOperation", "")
            a.ActivateObjectSelTool("")
            a.ApplyTopoOp("Inverse", "", 3, "siPersistentOperation", "")
            a.SetValue(".polymsh.invsrf.inv", False, "")
            oProgressBar.Increment()

            Application.SelectObj(listx)

    if lista and listx:
        Application.AddToSelection(lista)
    elif lista:
        Application.SelectObj(lista)

    oProp = XSIFactory.Createobject( 'CustomProperty' )
    oProp.Name = "Quick Thickness"

    oProp.addparameter2( "Thickness", 5, 1, -100, 100, -5, 5)
    oProp.addparameter2( "Subdivs", 2, 0, 0, 100, 0, 5)
    oProp.addparameter2( "Inset", 5, 0, -100, 100, -5, 5)

    oLayout = oProp.PPGLayout

    oLayout.AddItem( 'Thickness', "Thickness" , c.siControlNumber)
    oLayout.AddItem( 'Subdivs', "Subdivs" , c.siControlNumber)
    oLayout.AddItem( 'Inset', "Inset" , c.siControlNumber)

    oLayout.Language = "Python"


    oLayout.Logic = '''
a = Application
sel = a.Selection
lm = LogMessage
list = []
for x in range(0, sel.Count):
    list.append(sel(x))
        

def Thickness_OnChanged():
    for y in range(0, len(list)):   
        list[y].ActivePrimitive.ConstructionHistory.Find( "extrudenormalop" ).Parameters(1).Value = PPG.Thickness.Value
        if PPG.Thickness.Value < 0:
            list[y].ActivePrimitive.ConstructionHistory.Find("invsrf").Parameters(0).Value = True
        else:
            list[y].ActivePrimitive.ConstructionHistory.Find("invsrf").Parameters(0).Value = False

def Subdivs_OnChanged():
    for y in range(0, len(list)):   
        list[y].ActivePrimitive.ConstructionHistory.Find( "extrudenormalop" ).Parameters(6).Value = PPG.Subdivs.Value
        
def Inset_OnChanged():
    for y in range(0, len(list)):   
        list[y].ActivePrimitive.ConstructionHistory.Find( "extrudenormalop" ).Parameters(2).Value = PPG.Inset.Value
    '''

    if listx or lista:
        a.inspectobj( oProp , "", "", 3) 

    return true

def QuickThickness_Menu_Init( in_ctxt ):
    oMenu = in_ctxt.Source
    oMenu.AddCommandItem("QuickThickness","QuickThickness")
    return true

